package sun.awt.windows;

import sun.awt.datatransfer.ToolkitThreadBlockedHandler;
import sun.awt.Mutex;

final class WToolkitThreadBlockedHandler extends Mutex implements ToolkitThreadBlockedHandler
{
    WToolkitThreadBlockedHandler() {
    }
    
    @Override
    public void enter() {
        if (!this.isOwned()) {
            throw new IllegalMonitorStateException();
        }
        this.unlock();
        this.startSecondaryEventLoop();
        this.lock();
        return;
    }
    
    @Override
    public void exit() {
        if (!this.isOwned()) {
            throw new IllegalMonitorStateException();
        }
        WToolkit.quitSecondaryEventLoop();
        return;
    }
    
    private native void startSecondaryEventLoop();
}
